<template>
	<div class="w-full md:w-690 lg:w-580 bg-white px-4 pt-10 pb-14 md:px-10 md:py-10 lg:px-14 lg:py-14 mx-auto">
		<div v-for="(item, index) in surveyList" :key="index" role="radiogroup" aria-labelledby="mk-radio-head">
			<h3 id="mk-radio-head" class="font-primary-font-bold text-xl leading-6 mb-8 lg:mb-12">
				{{ item.question }}
			</h3>
			<div v-for="(survey, s_index) in item.responses" :key="s_index" class="flex w-full mb-6">
				<MkCheck
					:radio-title="survey"
					:tab-value="selected == survey || (s_index == 0 && !selected) ? 0 : -1"
					role-type="radio"
					check-type="radio"
					:checked="selected == survey"
					@change="selected = survey"
				/>
			</div>
			<div
				v-if="selected == 'Other'"
				class="border rounded md:rounded-md px-4 py-4 md:px-6 md:py-4 leading-5 md:leading-6 mb-10 md:mb-8 lg:mb-12 w-full focus-within:border-black"
				:class="selected == 'Other' ? 'border-black' : 'border-grey-20'"
			>
				<textarea
					id="turningoffothers"
					v-model="otherReason"
					class="font-primary-font-light text-sm md:text-base text-black w-full h-100 md:h-72 mt-4 md:mt-2 lg:mt-4 rounded resize-none block border-none focus:border-none focus:outline-none p-0 focus:shadow-none focus:ring-0"
					aria-labelledby="others"
					aria-describedby="info"
					placeholder="Please enter your answer"
				></textarea>
			</div>
		</div>
		<div class="flex justify-center items-center">
			<MkPrimaryButton
				tabindex="0"
				:disabled="(!selected && selected !== 'Other') || (selected === 'Other' && !otherReason)"
				btn-class="h-14 md:h-10"
				class="w-full md:w-210 font-primary-font-regular text-xl leading-6 focus:ring mt-10 md:mt-2 lg:mt-6"
				button-title="Submit answer"
				@click="surveySelected()"
			/>
		</div>
	</div>
</template>

<script>
import { mapState } from 'vuex';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
export default {
	name: 'MkFAQComponent',
	components: {
		MkPrimaryButton,
		MkCheck,
	},
	data() {
		return {
			list: [],
			selected: '',
			otherReason: '',
		};
	},
	computed: {
		...mapState('USER_STORE', ['ORDER']),
		newList() {
			return this.$store.state.CHECKOUT_STORE.SURVEY_QUESTIONS;
		},
		surveyList() {
			if (this.newList) {
				return this.newList.surveyQuestions;
			} else {
				return this.list;
			}
		},
	},
	async mounted() {
		await this.$store.dispatch('CHECKOUT_STORE/LOAD_SURVEYS');
	},
	methods: {
		async surveySelected() {
			try {
				if (Object.keys(this.ORDER).length !== 0) {
					const { customerId, customerEmail } = this.ORDER;
					const customerNumber = this.ORDER.custom?.fields?.customerNumber;
					const params = {
						customerId,
						customerEmail,
						customerNumber,
						surveyResponse: this.selected,
						other: false,
					};
					if (this.selected === 'Other') {
						params.other = true;
						params.surveyResponse = this.otherReason;
					}
					const res = await this.$repositories.checkout.addSurveyResponse(params);
					if (res.status === 200 && res.data) {
						this.$emit('survey-success');
						this.tealiumFormSubmit('form_submit', this.selected);
					} else {
						this.tealiumFormSubmit('form_submit_fail', this.selected, res.data.error);
					}
				}
			} catch (error) {
				this.tealiumFormSubmit('form_submit_fail', this.selected, error);
				// Error Handling
			}
		},
		tealiumFormSubmit(key, value, errorMsg) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const industry = this.$store.state.USER_STORE.CUSTOMER;
			const tealiumPayload = {
				event_category: 'Promotion Submission',
				event_action: 'Generic Promotional Form',
				event_label: window.location.href,
				event_value: value,
				page_type: 'Thank you',
				customer_tos_opt_in: 'True',
				customer_refill_opt_in: this.ORDER?.hasSubscription,
				customer_marketing_opt_in: 'False',
				customer_email_preference: customerDetails.customer_email,
				customer_type: 'MO-Registered',
				customer_industry_category: industry ? industry?.companyCategory?.name : '',
				cart_id: this.ORDER?.cart?.id,
				cart_discount: [this.$root.$utility.centsToDollarsConvert(this.ORDER?.custom?.fields?.totalDiscountPrice) || 0],
				cart_product_id: [...new Set(this.ORDER?.lineItems.map((x) => x.productId))],
				cart_product_quantity: [...new Set(this.ORDER?.lineItems.map((x) => x.quantity))],
				cart_product_sku: [...new Set(this.ORDER?.lineItems.map((x) => x.variant.sku))],
				cart_total_items: this.ORDER?.lineItems.length.toString(),
				cart_total_value: this.$root.$utility.centsToDollarsConvert(this.ORDER?.custom?.fields?.orderTotal),
				...customerDetails,
			};
			const listPriceArray = [];
			const productListPrice = [...new Set(this.ORDER?.lineItems.map((x) => x.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPriceArray.push(this.$root.$utility.centsToDollarsConvert(el.value.centAmount));
				}
			});
			if (key === 'form_submit_fail') {
				tealiumPayload.event_value = errorMsg;
			}
			tealiumPayload.cart_product_list_price = listPriceArray;
			tealiumPayload.cart_product_price = listPriceArray;
			this.$root.$telium.setTealiumPayload(key, tealiumPayload);
		},
	},
};
</script>
